import sys, random
from mcpi import minecraft
mc = minecraft.Minecraft.create()

mc.postToChat("Bienvenue dans mon MineLabyr !")

def realx(x):
  return LABYX + (x*2) - 1

def realz(z):
  return LABYZ + (z*2) - 1

def montrerBloc(x, z):
  mc.setBlock(realx(x), SOL+1, realz(z), 41) # 41 = Or

def cacherBloc(x, z):
  mc.setBlock(realx(x), SOL+1, realz(z), 0)

def demolir(realx, realz):
  mc.setBlocks(realx, SOL+1, realz, realx, HAUT+SOL, realz, 0)

def testerMurs(caseX, caseZ):
  if mc.getBlock(realx(caseX)+1, SOL+1, realz(caseZ))==LABY_MATER and mc.getBlock (realx(caseX)-1, SOL+1, realz(caseZ))==LABY_MATER and mc.getBlock(realx(caseX), SOL+1, realz(caseZ)+1)==LABY_MATER and mc.getBlock(realx(caseX), SOL+1, realz(caseZ)-1)==LABY_MATER:
    return True
  else:
    return False

mc.setting("world_immutable", True)

# Configuration
DIM = 10
HAUT = 2
LABYX = 0
SOL = 0
LABYZ = 0
LABY_MATER = 1 # 1 = Pierre
SOL_MATER = 2  # 2 = Herbe
TOIT = False

# Nettoyage de la zone
mc.setBlocks(LABYX-10, SOL, LABYZ-10, LABYX+(DIM*2)+10, SOL+150,
LABYZ+(DIM*2)+10, 0) # air

# Pose du plancher
mc.setBlocks(LABYX-10, SOL, LABYZ-10, LABYX+(DIM*2)+10, SOL,
LABYZ+(DIM*2)+10, SOL_MATER)

# Repérage d’origine
mc.setBlock(LABYX, SOL+HAUT+1, LABYZ, LABY_MATER)

# Amener le joueur au dessus du milieu
mc.player.setTilePos(LABYX+DIM, SOL+25, LABYZ+DIM)

mc.postToChat("Construction du labyrinthe...")

# Construction de la gaufre
for line in range(0, (DIM+1)*2, 2):
  mc.setBlocks(LABYX+line, SOL+1, LABYZ, LABYX+line, SOL+HAUT, LABYZ+(DIM*2), LABY_MATER)
  mc.setBlocks(LABYX, SOL+1, LABYZ+line, LABYX+(DIM*2), SOL+HAUT, LABYZ+line, LABY_MATER)

# Définition des variables
qCasesTot = DIM * DIM
qCasesVues = 1 # 1 car on commence dans une case
listeCasesVues = []

posX = random.randint(1, DIM)
posZ = random.randint(1, DIM)
joueurX = posX
joueurZ = posZ
montrerBloc(posX, posZ)
listeCasesVues.append((posX, posZ))

# BOUCLE PRINCIPALE
while qCasesVues < qCasesTot:
  possibleDirections = []

  if testerMurs(posX - 1, posZ):
    possibleDirections.append("GAU")
  if testerMurs(posX + 1, posZ):
    possibleDirections.append("DRO")
  if testerMurs(posX, posZ - 1):
    possibleDirections.append("AVA")
  if testerMurs(posX, posZ + 1):
    possibleDirections.append("ARR")

  cacherBloc(posX, posZ)

  if len(possibleDirections) != 0:
    directionChosen=random.choice(possibleDirections)

    # Abattre un mur dans une direction choisie
    if directionChosen == "GAU":
      demolir(realx(posX) - 1, realz(posZ))
      posX -= 1
    if directionChosen == "DRO":
      demolir(realx(posX) + 1, realz(posZ))
      posX += 1
    if directionChosen == "AVA":
      demolir(realx(posX), realz(posZ) - 1)
      posZ -= 1
    if directionChosen == "ARR":
      demolir(realx(posX), realz(posZ) + 1)
      posZ += 1

    qCasesVues += 1
    listeCasesVues.append((posX, posZ))
    montrerBloc(posX, posZ)

  else: # Toutes les voisines ont été vues
    retrace = listeCasesVues.pop()
    posX = retrace[0]
    posZ = retrace[1]
    montrerBloc(posX, posZ)

if TOIT == True:
  mc.setBlocks(LABYX, SOL+HAUT+1, LABYZ, LABYX+(DIM*2), SOL+HAUT+1,LABYZ+(DIM*2), 20)

  mc.postToChat("Labyrinthe disponible !")
  mc.postToChat("Bonne promenade !")
  mc.player.setTilePos(realx(joueurX), SOL+1, realz(joueurZ))
  

