#!/usr/bin/python3
# Electronic dice. par Mike Cook
import time, random
import RPi.GPIO as io

numLED     = [23,4,25,10,17,8,22]
aleaMotifs = [0,0x08,0x41,0x2A,0x63,0x6B,0x77]
inter  = 7

def main():
   print("DE ELECTRONIQUE - Ctrl C pour quitter")
   initGPIO()
   nombre = 1
   while 1:
      afficherRouler()
      afficherNombre(nombre)
      nombre = genererNombre()

def afficherRouler():        # Suite de motifs pour faire rouler
   for i in range(0,20):
     afficherNombre(random.randint(1,6))
     time.sleep(0.1)

def afficherNombre(nombre):
    motif = aleaMotifs[nombre]
    for i in range(0, len(numLED)):
       io.output(numLED[i], motif & 1)
       motif = motif >> 1

def genererNombre():     # Attente d'appui
    lancer = random.randint(1,6)
    while io.input(inter) == 1:
        pass
    time.sleep(0.030)    # Antirebond
    while io.input(inter) == 0:
       lancer += 1
       if lancer >6:     # Reboucle
          lancer = 1
    return lancer

def initGPIO():
    io.setmode(io.BCM)
    io.setwarnings(False)
    for pin in range (0,len(numLED)):
       io.setup(numLED[pin],io.OUT)      # pin passe en sortie
    io.setup(inter,io.IN,pull_up_down=io.PUD_UP) 
# pin redevient en entree

# Logique principale
if __name__ == '__main__':
  try:
    main()
  except KeyboardInterrupt:
    for i in range(0, len(numLED)):
       io.output(numLED[i], 0)
    pass

