#!/usr/bin/python3
# Pedestrian crossing Par Mike Cook
import time, random
import RPi.GPIO as io

# Modif sorties GPIO pour recycler branchement existant
broLED = [23,25,8,4,17,10]
broAppel = 7
broCapTrafic = 18
hrSeqSuivante = time.time()

def main():
   global hrDerTrafic, etat, sonore
   print("Emulateur de passage pietons - Ctrl C pour quitter")
   initGPIO()
   io.output(fVert,1) # Feu vert pour commencer
   etat = 0
   hrSonore = time.time()
   sonore = False
   hrDerTrafic = time.time()
   while 1:
      testerTrafic()
      if testerAppel() and etat == 0 :
         io.output(piStop,1)  # Allumer feu attendre
         if time.time() - hrDerTrafic > 10.0: # Traverser
            etat = 1
         else:
            time.sleep(10.0)   # Laisser passer qqs vehicules
            etat = 1
      gererTraversee()
      if sonore and time.time() > hrSonore:
         hrSonore = time.time() +0.3
         io.output(bruiteur,not(io.input(bruiteur)))

def testerTrafic():
   global hrDerTrafic
   if io.input(broCapTrafic) == 0:
      hrDerTrafic = time.time()

def testerAppel():
   request = False
   if io.input(broAppel) == 0:
      request = True
   return request

def gererTraversee():
   global hrSeqSuivante,nbrFlash,etat,sonore
   if etat == 0:
      hrSeqSuivante = time.time() + 2.0
      return
   if time.time() > hrSeqSuivante :
      if etat == 1:           # Feu orange
         # print("Etat actuel=",etat)
         io.output(fVert,0)
         io.output(fOrange,1)
         etat = 2
         hrSeqSuivante = time.time() + 2.0 # Temps fOrange
      elif etat == 2:         # Feu rouge
         # print("Etat actuel=",etat)
         io.output(fOrange,0)
         io.output(fRouge,1)
         etat = 3
         hrSeqSuivante = time.time() + 2.0 # Temps fRouge
      elif etat == 3:         # Feu pietons
         # print("Etat actuel=",etat)
         io.output(piStop,0)
         io.output(piTrav,1)
         sonore = True
         etat = 4
         hrSeqSuivante = time.time() + 5.0 # Temps trav.
      elif etat == 4:        # Orange pour fin pietons
         # print("Etat actuel=",etat)
         io.output(fOrange,1)
         io.output(fRouge,0)
         sonore = False
         io.output(bruiteur,0)     # Stop bruiteur
         etat = 5
         hrSeqSuivante = time.time() + 1.0
      elif etat == 5:           # Cligno orange et pietons
         # print("Etat actuel=",etat)
         io.output(fOrange,not(io.input(fOrange)))
         io.output(piTrav,not(io.input(piTrav)))
         hrSeqSuivante = time.time() + 0.2 # Vitesse cligno
         nbrFlash +=1
         if nbrFlash > 20 : # Temps trav. 20 * vit. cligno
            nbrFlash = 0
            etat = 6
      elif etat == 6: # fOrange
         io.output(piTrav,0)
         io.output(piStop,1)
         io.output(fOrange,1)
         etat = 7
         hrSeqSuivante = time.time() + 2.0 # Temps fOrange
      elif etat == 7:
         # print("Etat actuel=",etat)
         io.output(fOrange,0)
         io.output(fVert,1)
         io.output(piStop,0)
         etat = 0
         hrSeqSuivante = time.time() + 1.0

def initGPIO():
   global fRouge, fOrange, fVert, piStop, piTrav, nbrFlash, bruiteur
   io.setmode(io.BCM)
   io.setwarnings(False)
   for pin in range (0,len(broLED)):
      io.setup(broLED[pin],io.OUT)        # Sortie
      io.output(broLED[pin],0)            # A zero
   io.setup(broAppel,io.IN,pull_up_down=io.PUD_UP) # Entree
   io.setup(broCapTrafic,io.IN,pull_up_down=io.PUD_UP)
   fRouge = broLED[0]
   fOrange = broLED[1]
   fVert = broLED[2]
   piStop = broLED[3]
   piTrav = broLED[4]
   bruiteur = broLED[5]
   nbrFlash = 0

# Main program logic:
if __name__ == '__main__':
  try:
    main()
  except KeyboardInterrupt:
    for i in range(0, len(broLED)):
       io.output(broLED[i], 0) # Car Feu vert reste sinon
    pass

