#!/usr/bin/python3
import time
import RPi.GPIO as io

io.setmode(io.BCM)
io.setup(17,io.OUT)       # Configuration en sortie
io.setup(27,io.OUT)
io.setup(22,io.OUT)

ledR = io.PWM(17,60)      # Frequence PWM = 60Hz
ledG = io.PWM(27,60)
ledB = io.PWM(22,60)

ledR.start(0)             # Lancement PWM
ledG.start(0)
ledB.start(0)

print("Balayage de LED RGB avec RPi.GPIO - Par Mike Cook")
print("Ctrl C pour quitter")
try:
   while(1):
       print("Debut de cycle")
       time.sleep(2.0)
       for stepR in range(0,100,5):            # 20 tours
          for stepG in range(0,100,5):         # 400 tours
             for stepB in range(0,100,5):      # 8000 tours
                ledR.ChangeDutyCycle(stepR)
                ledG.ChangeDutyCycle(stepG)
                ledB.ChangeDutyCycle(stepB)
                time.sleep(0.1)                # 8000 fois
                ledR.ChangeDutyCycle(0)
                ledG.ChangeDutyCycle(0)
                ledB.ChangeDutyCycle(0)

except KeyboardInterrupt:
   pass

ledR.stop(0)      # Arret PWM
ledG.stop(0)
ledB.stop(0)
io.cleanup()      # Restaure les etats GPIO initiaux
