#!/usr/bin/env python3
# KeepeeUpee by Mike Cook

import RPi.GPIO as io
import time, random
from apa102bangfr import Apa102bangfr

nBarette = 8

def main():
  global encore,altiBal,coulBal
  print("Keepee Upee FR")
  init()
  encore = True
  sensBallon = -1
  altiBal = nBarette 
  pied = 0
  score = 0
  vitesseK = vitesseJ
  plato.changerLed(0,coulPied[pied]) 
  plato.afficher()
  time.sleep(vitesseJ)
  mouvBalSuiv = time.time()+vitesseJ
  kickPrec = not(io.input(broKick))
  while 1:
    while encore:
      kickNouv = not(io.input(broKick))
      if kickNouv and not(kickPrec) :
        if altiBal == 0: #   kick
           sensBallon = sensBallon * -1
           # Accelerer si en retard
           if mouvBalSuiv - time.time() < vitesseK/2 :
             vitesseK = vitesseK / 2
           else:
             vitesseK = vitesseJ
           mouvBalSuiv = time.time()-1.0
           pied = 1
           score += 1 # Augmenter score
        else:
          pied = 2        
      if time.time() > mouvBalSuiv:
         plato.changerLed(altiBal,(0,0,0))
         altiBal += sensBallon  
         plato.changerLed(0,coulPied[pied])
         plato.changerLed(altiBal,coulBal)         
         pied = 0
         mouvBalSuiv = time.time()+vitesseK
      if altiBal >= nBarette-1 :
         sensBallon = -1
      if altiBal < 0: # Ballon manque
         encore = False
      kickPrec = kickNouv   
      plato.afficher()
    print("Ballon par terre. Votre score:",score)
    while not(io.input(broKick)):
        pass
    time.sleep(vitesseJ* 5)         
    print("Appuyez pour rejouer")
    while not(io.input(broKick)):
        pass
    score = 0
    encore = True
    altiBal = nBarette
    sensBallon = -1
    plato.afficher()
    vitesseK = vitesseJ
    while io.input(broKick):
        pass
  
def init():
   global broKick,plato,vitesseJ,coulPied,coulBal
   random.seed()
   io.setmode(io.BCM)
   broKick = 4
   io.setup(broKick,io.IN, pull_up_down=io.PUD_UP)
   lumi = 4
   dataPin  = 23
   clockPin = 24 # Blinkit 
   plato = Apa102bangfr(nBarette,dataPin,clockPin,lumi)
   vitesseJ = 0.3 
   coulBal  = (128,128,0)
   coulPied = [(32,32,32),(128,0,0),(0,0,128)]
        
# Main program logic:
if __name__ == '__main__':    
  try:
    main()
  except KeyboardInterrupt:
    pass
# turn off all LEDs  
plato.changerTout((0,0,0))
plato.afficher() 

