#!/usr/bin/env python3
# Broche avec matrice AdaFruit 8X8
# VF par O.E.

import time, random
from apa102bangfr import Apa102bangfr

broData = 23
broClock = 24 
lumi = 1
lenX = 8
lenY = 8
nbrLED = lenX * lenY
demi = int(nbrLED / 2)
dureeMotif = 8.0
matri = Apa102bangfr(nbrLED,broData,broClock,lumi) 

def main():
   print("Matrice APA102 8x8 - Ctrl-C pour quitter")
   tpsProchain = time.time() + dureeMotif
   motif = 1
   while True:
      if motif == 1:
         motiver1()
      if motif == 2:
         motiver2()
      if motif == 3:
         motiver3()
      if time.time() > tpsProchain:
         tpsProchain = time.time() + dureeMotif
         motif +=1
         if motif > 3:
            motif = 1

def motiver1():
     for cote in range(1,lenX):  
       for i in range(0,lenX):
          carrer(i,i,cote,aleaCoul())
          matri.afficher()
          time.sleep(0.1)
       time.sleep(0.6)
       matri.changerTout((0,0,0))
     matri.changerTout((0,0,0))
     time.sleep(0.6)
     
def motiver2():
   start = 0
   for cote in range(lenX-1,0,-2):
      carrer(start,start,cote,aleaCoul())
      matri.afficher()
      time.sleep(0.08)
      start += 1
   #time.sleep(0.6)
   #matri.changerTout((0,0,0))
     
def motiver3():
   col = aleaCoul()
   for t in range(1,8):
      ligner(0,0,t,0,col)
      retenir()    
   for t in range (1,8):
      ligner(0,0,8,t,col)
      retenir()
   for t in range (8,0,-1):
      ligner(0,0,t,8,col)
      retenir()   
   for t in range(7,0,-1):
      ligner(0,0,0,t,col)
      retenir()
         
def retenir():      
   matri.afficher()
   time.sleep(0.08)
   matri.changerTout((0,0,0))
      
def matricer(x,y,col):
   pixel = x + y*8
   if pixel < nbrLED and x < lenX:
      matri.changerLed(pixel,col)

def kRemplir(x,y,cote,col):
   for xp in range(x,x+cote):
      for yp in range(y,y+cote):
         matricer(xp,yp,col)
            
def carrer(x,y,cote,col):
   for xp in range(x,x+cote):
      matricer(xp,y,col)
   for xp in range(x,x+cote+1):
      matricer(xp,y+cote,col)
   for yp in range(y,y+cote):
      matricer(x,yp,col)  
   for yp in range(y,y+cote):
      matricer(x+cote,yp,col)
      
def ligner(xs,ys,xe,ye,col):   
   xl = xe - xs
   yl = ye - ys
   if xl > yl:
      xinc = 1.0
      yinc = yl/xl
   else:
      yinc = 1.0
      xinc = xl/yl
   x= float(xs) ; y = float(ys)
   while x != xe or y != ye:
      matricer(int(x),int(y),col)
      x += xinc
      y += yinc
      
def aleaCoul():
   r = 0; g =0; b=0
   while r+g+b == 0:
      r = random.randint(0,2) * 64
      g = random.randint(0,2) * 64
      b = random.randint(0,2) * 64
   return (r,g,b)
   
if __name__ == '__main__':    
  try:
    main()
  except KeyboardInterrupt:
    pass
# tout eteindre 
matri.changerTout((0,0,0))
matri.afficher() 

