#!/usr/bin/env python3
# Classe pilote pour  LED APA102
# par Mike Cook
# VF par Olivier Engler

import RPi.GPIO as io
io.setwarnings(False)

class Apa102bangfr():   # VF : nom de classe avec fr
    
    def __init__(self,nombreLED,data,clock,brillance):
       self.changerLumiGen(brillance) 
       self.da = data
       self.ck = clock
       self.nbrLed = nombreLED
       io.setmode(io.BCM)
       io.setup(self.ck,io.OUT)
       io.setup(self.da,io.OUT)
       io.output(self.ck, io.HIGH)
       io.output(self.da, io.HIGH)
       self.tabLed = [self.br<<24 for i in range(0,self.nbrLed)]
       
    def changerLumiGen(self,lumino):
        if lumino > 31:
           lumino = 31
        if lumino < 0:
           lumino = 0          
        self.br = lumino | 0xE0

    def changerLed(self,pos,col):
        if pos < self.nbrLed and pos >= 0:
           self.tabLed[pos] = (self.br<<24)|(col[2]<<16)|(col[1]<<8)|col[0]
        
    def changerTout(self,col):
        for i in range(0,self.nbrLed):
          self.tabLed[i] = (self.br<<24)|(col[2]<<16)|(col[1]<<8)|col[0]
          
    def afficher(self): 
       io.output(self.da,io.LOW)
       for i in range(0,32):         # En-tete
         io.output(self.ck, io.LOW)
         io.output(self.ck, io.HIGH)
       for i in range(0,self.nbrLed):
          d = self.tabLed[i]         # Donnees
          for j in range(0,32):
            io.output(self.ck, io.LOW)
            if d & 0x80000000 :
              io.output(self.da, io.HIGH)
            else:
              io.output(self.da, io.LOW)
            d = d << 1
            io.output(self.ck, io.HIGH)
       io.output(self.da, io.LOW)     
       for i in range(0,33+(self.nbrLed>>1)): # Pied (fin)
         io.output(self.ck, io.LOW)
         io.output(self.ck, io.HIGH)
