#!/usr/bin/env python
# RFID Jukebox Enroll - stocke noms dans secteurs 4&5
# par Mike Cook
# VF par O.E.
 
from rc522rfid import Rc522rfid
import os

lectRF = Rc522rfid()

def main():
   print ("Declareur pour Jukebox RFID")
   print ("Ctrl-C pour quitter.")
   listerSons()
   for numFic in range(0,len(listeSons)):
      action = ""
      print( listeSons[numFic] )
      print("Touche (e) ou Entree pour ignorer")
      action = input()
      if action == "e" :
         declarer(listeSons[numFic])

def declarer(nomFic):
   print("Stockage de", nomFic, ". Presentez une carte.")
   data1 = []
   data2 = []
   for i in range(0,16): # Remplir de zeros
      data1.append(0)
      data2.append(0)
   for i in range(0,len(nomFic)):
      if i < 16:
         data1[i] = ord(nomFic[i])
      else:
         data2[i-16] = ord(nomFic[i])         
   # Cle par defaut pour authentification
   key = [0xFF,0xFF,0xFF,0xFF,0xFF,0xFF]
   lectRF.RC522_WriteSector(key,4,data1)
   lectRF.RC522_WriteSector(key,5,data2)   
   print("Fin de session\n")
 
def listerSons():
   global listeSons
   chemin = os.path.abspath("/home/pi/Music/")
   # Obtention liste de noms
   listeSons = [fn for fn in next(os.walk(chemin))[2]]
   list.sort(listeSons)         # Tri alpha
   print (len(listeSons),"fichiers.")
   
#
if __name__ == '__main__':
  try:
    main()
  except KeyboardInterrupt:
    pass

            
