#!/usr/bin/python3
# RFID Jukebox2 par Mike Cook
# VF par O.E.
 
from rc522rfid import Rc522rfid
import pygame

pygame.mixer.quit()
pygame.mixer.init(frequency=22050, size=-16, channels=2, buffer=512)   
lectRF = Rc522rfid()

def main():
   print ("RFID Jukebox avec cartes declarees")
   print ("Ctrl-C pour quitter.")
   while 1:        # Infiniment
      aLire = lireCarte()
      pygame.mixer.music.stop()
      try :
         pygame.mixer.music.load("/home/pi/Music/"+aLire)
         pygame.mixer.music.play()
         print("Lecture de:- "+aLire)
      except :
         print("Pas de fichier:-/home/pi/Music/"+aLire)
      lectRF.RC522_WaitForCardRemoved()   

def lireCarte():
   # Cle d'authentification par defaut
   key = [0xFF,0xFF,0xFF,0xFF,0xFF,0xFF]
   block1 = lectRF.RC522_GetSector(key,4)
   block2 = lectRF.RC522_GetSector(key,5)
   if block1 != -1 and block2 != -1:
      nomFicAjouer = rabouter(block1,block2)
      return nomFicAjouer
   else:
      return("Erreur de lecture de carte")

def rabouter(s1,s2):
   nom = ""
   i = 0
   pasFini = True
   while pasFini and i < 32:
      if i<16:
         c = s1[i]
      else:
         c = s2[i-16]
      i+=1
      if c !=0:     
        nom = nom + chr(c)
      else:
        pasFini = False  
   return nom   
   
# 
if __name__ == '__main__':
  try:
    main()
  except KeyboardInterrupt:
    pygame.mixer.quit()

            
