#!/usr/bin/env python
#RFID Jukebox Enroll - puts music files names on sectors 4&5
# by Mike Cook
 
from rc522rfid import Rc522rfid
import os

rfidReader = Rc522rfid()

def main():
   print ("RFID Jukebox card enroller")
   print ("Press Ctrl-C to stop.")
   getFiles()
   for file in range(0,len(soundList)):
      action = ""
      print( soundList[file] )
      print("Enrol (e) or just Return to Skip")
      action =input()
      if action == "e" :
         enrol(soundList[file])

def enrol(name):
   print("Enrolling", name, "place a card on the reader")
   data1 = []
   data2 = []
   for i in range(0,16): # fill with a sectors worth of zeros
      data1.append(0)
      data2.append(0)
   for i in range(0,len(name)):
      if i < 16:
         data1[i] = ord(name[i])
      else:
         data2[i-16] = ord(name[i])         
   # This is the (default) key for authentication
   key = [0xFF,0xFF,0xFF,0xFF,0xFF,0xFF]
   rfidReader.RC522_WriteSector(key,4,data1)
   rfidReader.RC522_WriteSector(key,5,data2)   
   print("finished enrolling\n")
 
def getFiles():
   global soundList
   path = os.path.abspath("/home/pi/Music/")
   #get a list of files
   soundList = [fn for fn in next(os.walk(path))[2]]
   list.sort(soundList) # put in alphabetical order
   print (len(soundList),"files found")
   
# Main program logic:
if __name__ == '__main__':
  try:
    main()
  except KeyboardInterrupt:
    pass

            
